"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.sendSchema = void 0;
const sp_internal_1 = require("@streamdal/protos/protos/sp_internal");
const register_js_1 = require("./register.js");
const sendSchema = ({ configs, audience, schema, }) => __awaiter(void 0, void 0, void 0, function* () {
    try {
        if (!schema) {
            console.info("No schema found, skipping send schema");
            return;
        }
        const key = (0, register_js_1.audienceKey)(audience);
        const existing = register_js_1.internal.schemas.get(key);
        if (!existing || existing.toString() !== schema.toString()) {
            register_js_1.internal.schemas.set(key, schema);
            const schemaRequest = sp_internal_1.SendSchemaRequest.create({
                audience,
                schema: { jsonSchema: schema },
            });
            console.debug("sending schema...");
            const call = configs.grpcClient.sendSchema(schemaRequest, {
                meta: { "auth-token": configs.streamdalToken },
            });
            yield call.headers;
            console.debug("schema sent");
        }
    }
    catch (e) {
        console.error("Error sending schema", e);
    }
});
exports.sendSchema = sendSchema;
